/* Name:		eingabe.cpp */
/* Autor:		Dirk B"achle */
/* Datum:		11.09.2000 */
/* Zweck:		Definition der Funktionen fr die Eingabe */
/*			und Ausgabe von Daten (Strings) */

/** Definition der Funktionen f"ur die Eingabe und Ausgabe von Daten (Strings).
\file eingabe.cpp
\author Dirk B"achle
\version 1.3
*/


/* ------------------------------------------------ Include-Dateien */

#include <stdio.h>
#include "globald.h"
#include "eingabe.h"

/* ---------------------------------------------- Globale Variablen */


/* ----------------------------------------------------- Funktionen */


int mystrlen(char *str)
/* Ermittelt die Anzahl der Zeichen des Strings */
{
  int cnt=0;

  while (str[cnt]!=0) cnt++;

  return(cnt);
}

void StrCut(char *sname,int cuts)
{
/* Schneidet die ersten cuts Zeichen aus einem String heraus */
  int len=mystrlen(sname),cnt=0,cmax=len-cuts;

  if (len>cuts)
  {
    while (cnt<cmax)
    {
      sname[cnt]=sname[cnt+cuts];
      cnt++;
    }
    sname[cnt]=0;
  }
  if (len==cuts)
    sname[0]=0;
}

int HashCount(char *textstr)
/* Ermittelt die Anzahl der # Zeichen im String */
{
  int cnt=0,hcnt=0;

  while (textstr[cnt]!=0)
  {
    if ((textstr[cnt]==35) && (textstr[cnt+1]!=0)) hcnt++;
    cnt++;
  }
  return(hcnt);
}

void DisplayErrorOccured(void)
{
  printf("Achtung! Der folgende Fehler ist aufgetreten:\n\n");
}

void DisplayFreeMemoryMessage(void)
{
  printf("\n\nDiese Fehlermeldung bedeutet, dass Sarius momentan nicht genuegend\n");
  printf("Speicher zur Verfgung hat. Es kann daher die gewnschte Aktion nicht\n");
  printf("richtig ausfhren.\n");
  printf("Entweder Sie haben bereits zu viele Vokabeln eingegeben, oder in ihrer\n");
  printf("DOS-Umgebung steht generell nur noch sehr wenig Platz zum Starten von\n");
  printf("Programmen zur Verfgung.\n");
  printf("Beenden Sie das Programm und reduzieren Sie die Anzahl der Vokabeln.\n");
  printf("Falls Sie Sarius unter DOS und nicht unter Windows benutzen, knnen Sie\n");
  printf("auch versuchen die Verwendung Ihres Hauptspeichers < 640KB mit Hilfe\n");
  printf("eines Programmes wie MEMMAKER oder OPTIMIZE zu optimieren.\n");
  printf("\n<< Bitte eine Taste drcken >>\n");
}

void DisplayWrongFileMessage(void)
{
  printf("\n\nDiese Fehlermeldung bedeutet, dass Sarius die Datei mit dem angezeigten\n");
  printf("Namen nicht ffnen kann.\n");
  printf("Es kann daher die gewnschte Aktion nicht richtig ausfhren.\n");
  printf("Vielleicht sind in Ihrer DOS-Umgebung bereits zu viele Dateien gleichzeitig\n");
  printf("geffnet. Arbeiten Sie mit Sarius von der Diskette und haben vielleicht\n");
  printf("vergessen den Schreibschutz zu entfernen? Versuchen Sie auf eine\n");
  printf("schreibgeschtzte Partition (z.B. ein CD-ROM-Laufwerk) zu speichern, oder\n");
  printf("auf einen Bereich zu dem Sie eigentlich keine Zugangsberechtigung haben?\n");
  printf("Entspricht der von Ihnen angegebene Name den DOS-Konventionen fr Datei-\n");
  printf("und Verzeichnisnamen (siehe \"8.3-Format\" in Ihrer DOS-Dokumentation)?\n");
  printf("Ist der Dateiname richtig, d.h. der gleiche unter dem Sie die Datei\n");
  printf("gespeichert haben?\n");
  printf("Prfen Sie diese Punkte nach und korrigieren Sie gegebenenfalls den\n");
  printf("Dateinamen. Versuchen Sie dann erneut die Aktion auszufhren.\n");
  printf("\n<< Bitte eine Taste drcken >>\n");
}

void DeleteBrackets(char *newstr)
/* Entfernt die Klammern [] aus dem String */
/* der Inhalt bleibt erhalten */
{
  char oldstr[MAXSTR];
  int ocnt=0, ncnt=0;

  while (newstr[ncnt]!=0)
  {
    if ((newstr[ncnt]!=91) && (newstr[ncnt]!=93))
    {
      oldstr[ocnt]=newstr[ncnt];
      ocnt++;
    }
    ncnt++;
  }
  oldstr[ocnt]=0;

  strcpy(newstr, oldstr);

}

void DeleteBraces(char *newstr)
/* Entfernt die Klammern {} aus einem String */
/* der Inhalt bleibt erhalten */
{
  char oldstr[MAXSTR];
  int ocnt=0, ncnt=0;

  while (newstr[ncnt]!=0)
  {
    if ((newstr[ncnt]!=123) && (newstr[ncnt]!=125))
    {
      oldstr[ocnt]=newstr[ncnt];
      ocnt++;
    }
    ncnt++;
  }
  oldstr[ocnt]=0;

  strcpy(newstr, oldstr);

}


void KillBrackets(char *newstr)
/* Entfernt die Klammern [] samt Inhalt aus dem String */
{
  char oldstr[MAXSTR];
  int ocnt=0, ncnt=0;

  while (newstr[ncnt]!=0)
  {
    if (newstr[ncnt]==91)
    {
      while ((newstr[ncnt]!=93) && (newstr[ncnt]!=0)) ncnt++;
      if (newstr[ncnt]!=0) ncnt++;
    }
    else
    {
      oldstr[ocnt]=newstr[ncnt];
      ncnt++;
      ocnt++;
    }
  }
  oldstr[ocnt]=0;

  strcpy(newstr, oldstr);

}


void KillBraces(char *newstr)
/* Entfernt die Klammern {} samt Inhalt aus dem String */
{
  char oldstr[MAXSTR];
  int ocnt=0, ncnt=0;

  while (newstr[ncnt]!=0)
  {
    if (newstr[ncnt]==123)
    {
      while ((newstr[ncnt]!=125) && (newstr[ncnt]!=0)) ncnt++;
      if (newstr[ncnt]!=0) ncnt++;
    }
    else
    {
      oldstr[ocnt]=newstr[ncnt];
      ocnt++;
      ncnt++;
    }
  }
  oldstr[ocnt]=0;

  strcpy(newstr, oldstr);

}

int GetNumberOfBracePairs(char *str)
/* Zhlt die Anzahl der Klammerpaare {} im String str */
{
  int ocnt=0, bcnt=0;

  while (str[ocnt]!=0)
  {
    if (str[ocnt]==123)
    {
      while ((str[ocnt]!=125) && (str[ocnt]!=0)) ocnt++;
      if (str[ocnt]!=0) bcnt++;
    }
    else
    {
      ocnt++;
    }
  }
  return(bcnt);
}

void GetBracesNo(char *newstr, char *oldstr, int braceno)
/* Speichert den Inhalt der Klammern {} mit der Nummer braceno */
/* in dem String newstr. */
{
  int ocnt=0, ncnt=0, bcnt=0, end=0;

  while ((oldstr[ocnt]!=0) && (end==0))
  {
    if (oldstr[ocnt]==123)
    {
      while ((oldstr[ocnt]!=125) && (oldstr[ocnt]!=0)) ocnt++;
      if (oldstr[ocnt]!=0)
      {
	bcnt++;
	if (bcnt==braceno)
	{
	  while (oldstr[ocnt]!=123) ocnt--;

	  ocnt++;

	  while (oldstr[ocnt]!=125)
	  {
	    newstr[ncnt]=oldstr[ocnt];
	    ncnt++;
	    ocnt++;
	  }
	  end=1;
	}
      }
    }
    else
    {
      ocnt++;
    }
  }
  newstr[ncnt]=0;
}

void KillBlanks(char *newstr)
/* Lscht alle Leerzeichen aus newstr */
{
  char oldstr[MAXSTR];
  int ocnt=0, ncnt=0;

  while (newstr[ncnt]!=0)
  {
    if (newstr[ncnt]!=32)
    {
      oldstr[ocnt]=newstr[ncnt];
      ocnt++;
    }
    ncnt++;
  }
  oldstr[ocnt]=0;

  strcpy(newstr, oldstr);

}

void ReduceBlanks(char *newstr)
/* Lscht die berflssigen Leerzeichen aus newstr */
{
  char oldstr[MAXSTR];
  int ocnt=0, ncnt=0;

  while ((newstr[ncnt]==32) && (newstr[ncnt]!=0)) ncnt++;

  while (newstr[ncnt]!=0)
  {
    if (newstr[ncnt]!=32)
    {
      oldstr[ocnt]=newstr[ncnt];
      ncnt++;
      ocnt++;
    }
    else
    {
      oldstr[ocnt]=newstr[ncnt];
      ncnt++;
      ocnt++;
      while ((newstr[ncnt]==32) && (newstr[ncnt]!=0)) ncnt++;
    }
  }

  if (oldstr[ocnt-1]==32) oldstr[ocnt-1]=0;
  else oldstr[ocnt]=0;

  strcpy(newstr, oldstr);

}

void KillHashs(char *newstr)
/* Lscht die Hash-Zeichen (#) aus newstr */
{
  char oldstr[MAXSTR];
  int ocnt=0, ncnt=0;

  while (newstr[ncnt]!=0)
  {
    if (newstr[ncnt]!=35)
    {
      oldstr[ocnt]=newstr[ncnt];
      ocnt++;
    }
    ncnt++;
  }
  oldstr[ocnt]=0;

  strcpy(newstr, oldstr);

}

int MaskStringWithByte(char *str, BYTE byte)
/* Maskiert den String mit dem Byte byte, d.h. */
/* alle Vorkommen des Bytes werden entfernt. */
/* Die Anzahl der entfernten Bytes wird zurueckgeliefert. */
{
  char oldstr[MAXSTR];
  int ocnt=0, scnt=0, bcnt=0;

  while (str[scnt]!=0)
  {
    if (str[scnt]!=((char) byte))
    {
      oldstr[ocnt]=str[scnt];
      ocnt++;
    }
    else
    {
      bcnt++;
    }

    scnt++;

  }
  oldstr[ocnt]=0;

  strcpy(str, oldstr);

  return(bcnt);

}

int CountWrongChars(char *answer, char *original)
/* Zhlt die Buchstaben, die in answer benutzt werden, aber */
/* nicht in original vorkommen (entsprechend ihrer Hufigkeit!). */
{
  char ahold[MAXSTR];
  BYTE actbyte;
  int wchars=0, mchars=0, ocnt=0;

  /* String kopieren */
  strcpy(ahold, answer);

  /* Wiederhole bis String leer = alle Buchstaben getestet */
  while (ahold[0]!=0)
  {
    /* Wie sieht das erste Zeichen aus? */
    actbyte = (BYTE) ahold[0];

    /* String mit Byte maskieren */
    mchars = MaskStringWithByte(ahold, actbyte);

    /* Pruefen, ob das Zeichen in original vorkommt */
    ocnt=0;
    while ((((char) actbyte)!=original[ocnt]) && (original[ocnt]!=0)) ocnt++;

    /* Wenn nein, die Anzahl der als falsch erkannten */
    /* Zeichen dazuaddieren */
    if (original[ocnt]==0) wchars=wchars+mchars;

  }

  return(wchars);
}

int GetTotalSum(int max)
/* Errechnet die Summe von 1 bis max */
{
  return(max*(max+1)/2);
}

void MyStringCut(char *strnew, char *strold, int strpos, int strcnt)
/* Schneidet aus strold ab der Position strpos */
/* strcnt Zeichen aus und kopiert sie nach strnew */
{
  int cnt=0;

  while (cnt<strcnt)
  {
    strnew[cnt]=strold[strpos+cnt];
    cnt++;
  }
  strnew[cnt]=0;
}

int mystrcmp(char *f, char *s)
/* Compares the two strings. Returns: */
/* 0 if string f is smaller than s */
/* 1 if strings are equal */
/* 2 if string f is greater than s */
{
  int cnt=0;

  while ((f[cnt]!=0) && (s[cnt]!=0) && (f[cnt]==s[cnt])) cnt++;
  if ((f[cnt]==0) && (s[cnt]==0)) return(1);
  if (f[cnt]==0) return(0);
  if (s[cnt]==0) return(2);
  if (s[cnt]<f[cnt]) return(2);
  else return(0);
}

int MyStringInString(char *strpiece, char *strtext)
/* Prft ob der Teilstring strpiece in strtext enthalten ist */
/* Liefert eine 1 wenn enthalten, sonst eine 0 */
{
  int found=0,ppos=0,tpos=0,plen=mystrlen(strpiece),tlen=mystrlen(strtext);

  if (tlen>plen)
  {
    ppos=plen-1;
    tpos=ppos;

    while ((tpos<tlen) && (found==0))
    {
      if (strtext[tpos]==strpiece[ppos])
      {
	while ((strtext[tpos-plen+ppos+1] == strpiece[ppos]) && (ppos>-1)) ppos--;

	if (ppos==-1) found=1;

	ppos=plen-1;
	tpos +=plen;
      }
      else tpos++;
    }

    if (found==0) return(0);
    else return(1);
  }
  else
  {
    if (tlen==plen)
    {
      /* Beide Strings sind gleich lang */
      /* Sind sie auch identisch? */
      if (mystrcmp(strpiece, strtext) == 1)
      {
	return(1);
      }
      else
      {
	return(0);
      }
    }
    else
    {
      /* Teil- ist lnger als der Gesamt-String */
      return(0);
    }
  }
}


double GetCongrPercent(char *answer, char *original)
/* Ermittelt die Prozentzahl der berdeckung zwischen */
/* Original und Antwort */
{
  char piece[MAXSTR],piece2[MAXSTR];
  int piececnt=2,acnt=0,incnt=0,alen=mystrlen(answer),olen=mystrlen(original),faktor=0,faktorsum=0;
  double percent=0.0,perchlp=0.0;


  if (mystrcmp(answer,original)==1) return(100.0);

  if ((answer[0]==0) || (original[0]==0)) return(0.0);

  /* Vermeidung des Compiler-Fehlers: Division by Zero */
  if ((alen<3) || (olen<3)) faktorsum=1;

  /* Prfen der berdeckung */
  while ((piececnt<alen) && (piececnt<olen))
  {
    while ((acnt+piececnt)<=alen)
    {
      MyStringCut(piece,answer,acnt,piececnt);
      if (MyStringInString(piece,original)==1) incnt++;

      acnt++;
    }

    /* Prozente */
    faktor=GetTotalSum(alen-piececnt);
    faktorsum +=faktor;
    perchlp=(double) (100.0*incnt*faktor/(1.0*acnt));

    percent +=perchlp;

    acnt=0;
    incnt=0;
    piececnt++;
  }

  percent=(double) percent/(1.0*faktorsum);


  /* Buchstabenmengen */
  strcpy(piece, answer);
  KillBlanks(piece);

  strcpy(piece2, original);
  KillBlanks(piece2);
  alen=mystrlen(piece);

  perchlp=(double) (100.0*(alen-CountWrongChars(piece,piece2)))/(1.0*alen);


  /* Prozente addieren */
  percent=(double) (percent+perchlp);

  alen=mystrlen(piece2);
  /* Gegenprfen der Buchstabenmengen */
  perchlp=(double) (100.0*(alen-CountWrongChars(piece2,piece)))/(1.0*alen);


  /* Zusammenrechnen aller dreier Prozentzahlen */
  percent=(double) (percent+perchlp)/3.0;

  /* Stimmen ueberhaupt keine Buchstaben ueberein? */
  if (percent == 0.0)
  {
    /* Dann gibt es keine Punkte */
    return(0.0);
  }

  /* Beruecksichtigen der Stringlaengen */
  alen=mystrlen(answer);
  olen=mystrlen(original);

  if (alen<olen)
  {
    perchlp=(double) (100.0*(olen-alen))/(1.0*olen);
    percent=(double) (3.0*percent+perchlp)/4.0;
  }
  if (alen>olen)
  {
    perchlp=(double) (100.0*(alen-olen))/(1.0*alen);
    percent=(double) (3.0*percent+perchlp)/4.0;
  }

  return(percent);
}

double CheckAnswer(char *answer, char *original, int killbrack, int killemph)
/* Macht den String fertig zur berprfung und */
/* ermittelt die Richtigkeit in Prozent */
{
  char acopy[MAXSTR], ocopy[MAXSTR], ohold[MAXSTR], ahold[MAXSTR];
  int obracemax=0, obrace=0, abracemax=0, abrace=0, anobrace=0, onobrace=0;
  double sumperc=0.0, maxperc=0.0, actperc=0.0;

  strcpy(acopy, answer);
  strcpy(ocopy, original);

  if (killbrack==1)
  {
    KillBrackets(acopy);
    KillBrackets(ocopy);
  }
  else
  {
    DeleteBrackets(acopy);
    DeleteBrackets(ocopy);
  }

  if (killemph==1)
  {
    KillHashs(acopy);
    KillHashs(ocopy);
  }

  /* Reduce blanks */
  ReduceBlanks(acopy);
  ReduceBlanks(ocopy);

  /* Is there a piece of text without braces in the answer? */
  strcpy(ahold, acopy);
  KillBraces(ahold);
  ReduceBlanks(ahold);
  if (ahold[0]!=0) anobrace = 1;

  /* Is there a piece of text without braces in the original? */
  strcpy(ohold, ocopy);
  KillBraces(ohold);
  ReduceBlanks(ohold);
  if (ohold[0]!=0) onobrace = 1;

  /* Get number of brace pairs */
  abracemax=GetNumberOfBracePairs(acopy);

  /* No Braces in the answer present ? */
  if (abracemax==0)
  {
    /* initialise ahold */
    strcpy(ahold, acopy);

    /* get number of brace pairs */
    obracemax=GetNumberOfBracePairs(ocopy);

    /* No Braces in the original present ? */
    if (obracemax==0)
    {
      /* No braces, so perform normal check */
      return(GetCongrPercent(ahold,ocopy));
    }
    else
    {
      /* There are braces, so check them one by one */
      for (obrace=1; obrace<=obracemax; obrace++)
      {
	GetBracesNo(ohold,ocopy,obrace);
	actperc=GetCongrPercent(ahold,ohold);
	if (actperc>maxperc) maxperc=actperc;
      }

      /* Now kill all braces, and check the remaining string */
      /* if there is one */
      if (onobrace == 1)
      {
	strcpy(ohold, ocopy);
	KillBraces(ohold);
	ReduceBlanks(ohold);

	actperc=GetCongrPercent(ahold,ohold);
	if (actperc>maxperc) maxperc=actperc;
      }

      return(maxperc);
    }
  }
  else
  {
    /* There are braces, so check them one by one */
    for (abrace=1; abrace<=abracemax; abrace++)
    {
      GetBracesNo(ahold,acopy,abrace);

      /* get number of brace pairs */
      obracemax=GetNumberOfBracePairs(ocopy);

      /* No Braces in the original present ? */
      if (obracemax==0)
      {
	/* No braces, so perform normal check */
	return(GetCongrPercent(ahold,ocopy));
      }
      else
      {
	/* There are braces, so check them one by one */
	for (obrace=1; obrace<=obracemax; obrace++)
	{
	  GetBracesNo(ohold,ocopy,obrace);
	  actperc=GetCongrPercent(ahold,ohold);
	  if (actperc>maxperc) maxperc=actperc;
	}

	/* Now kill all braces, and check the remaining string */
	/* if there is one */
	if (onobrace == 1)
	{
	  strcpy(ohold, ocopy);
	  KillBraces(ohold);
	  ReduceBlanks(ohold);

	  actperc=GetCongrPercent(ahold,ohold);
	  if (actperc>maxperc) maxperc=actperc;
	}

      }

      sumperc=sumperc+maxperc/(((double) abracemax+anobrace)*1.0);


    }

    /* Now kill all braces, and check the remaining string */
    /* if there is one */
    if (anobrace == 1)
    {
      strcpy(ahold, acopy);
      KillBraces(ahold);
      ReduceBlanks(ahold);

      /* get number of brace pairs */
      obracemax=GetNumberOfBracePairs(ocopy);

      /* No Braces in the original present ? */
      if (obracemax==0)
      {
	/* No braces, so perform normal check */
	return(GetCongrPercent(ahold,ocopy));
      }
      else
      {
	/* There are braces, so check them one by one */
	for (obrace=1; obrace<=obracemax; obrace++)
	{
	  GetBracesNo(ohold,ocopy,obrace);
	  actperc=GetCongrPercent(ahold,ohold);
	  if (actperc>maxperc) maxperc=actperc;
	}

	/* Now kill all braces, and check the remaining string */
	/* if there is one */
	if (onobrace == 1)
	{
	  strcpy(ohold, ocopy);
	  KillBraces(ohold);
	  ReduceBlanks(ohold);

	  actperc=GetCongrPercent(ahold,ohold);
	  if (actperc>maxperc) maxperc=actperc;
	}

      }

      sumperc=sumperc+maxperc/(((double) abracemax+anobrace)*1.0);

    }

    return(sumperc);
  }
}

void UnCr(char *sname)
/* Schneidet das letzte Zeichen (CR/LF) aus dem String */
{
  int cnt=mystrlen(sname);

  cnt--;
  sname[cnt]=0;
}

void EnterFileName(char *fn)
/* Neuen Dateinamen eingeben */
{

  printf("Please enter file name:\n");
  scanf("%s", fn);

}

/* Ende von eingabe.cpp */


